-- INPUT
function mousepressed(x, y, button)
	setCamera(worldCam)
	if button == love.mouse_left and player.m > 0 then
		controls.move.push(entities[player.i], love.mouse.getPosition())
	end
	
	
	if button == love.mouse_wheelup -- zoom IN
	 and not love.keyboard.isDown(love.key_lctrl)
	 and player.m > 0
	 and math.min(l_g:getWidth(), l_g:getHeight()) > player.r*12
	 then
		local width = l_g:getWidth()*getCamera():getScaleFactor()/scale
		local height = l_g:getHeight()*getCamera():getScaleFactor()/scale
		if love.keyboard.isDown(love.key_tab) then
			scale = scale*math.min(width,height) / (player.r*12)
		else
			scale = scale*math.min(1.2,
								   math.min(width,height) / (player.r*12) )
		end
	end
	if button == love.mouse_wheeldown -- zoom OUT
	 and not love.keyboard.isDown(love.key_lctrl)
	 and ((world_width*1.2)*2 > l_g:getWidth()
	 or  (world_height*1.2)*2 > l_g:getHeight())
	 then
		local width = l_g:getWidth()*getCamera():getScaleFactor()/scale
		local height = l_g:getHeight()*getCamera():getScaleFactor()/scale
		if love.keyboard.isDown(love.key_tab) then
			scale = scale*math.min(width  / ((world_width*1.2)*2),
		                              height / ((world_height*1.2)*2) )
		else
			scale = scale*math.max(1/1.2,
								   math.min(width  / ((world_width*1.2)*2),
											height / ((world_height*1.2)*2) )  )
		end
	end

	if button == love.mouse_wheelup -- faster
	 and love.keyboard.isDown(love.key_lctrl)
	 and game.speed < 10
	 then
		game.speed = game.speed+1
	end
	if button == love.mouse_wheeldown -- slower
	 and love.keyboard.isDown(love.key_lctrl)
	 and game.speed > 1
	 then
		game.speed = game.speed-1
	end
	if button == love.mouse_middle -- reset speed
	 then
		game.speed = 2
	end
end
function mousereleased(x, y, button)
	setCamera(worldCam)
	if button == love.mouse_left then
		controls.move.timer = 0
		controls.move.hold = 0
	end
end

function keypressed(key)
	if key == love.key_backspace then love.system.restart() end	-- BACKSPACE: restart system
	if key == love.key_f5 then
		load()
	end
	if key == love.key_escape	 then love.system.exit() end	-- ESCAPE:        exit       system
end
