world_height = 30
world_width = 40
world.matter = world_height * world_width * 0.05

function world.draw()
	love.graphics.setColor(love.graphics.newColor(0, 100, 150))
	love.graphics.rectangle(1, -world_width, -world_height, world_width*2, world_height*2)
end

function world.update()
	game.goal = 0
	for i, v in pairs(entities) do
		world.matter = world.matter + v.m
		
		-- walls around the world
		if v.x+v.r > world_width  then
			v.x = world_width-v.r
			if v.sx > 0 then
				v.sx = -v.sx
			end
		elseif v.x-v.r < -world_width then
			v.x = -world_width+v.r
			if v.sx < 0 then
				v.sx = -v.sx
			end
		end
		if v.y+v.r > world_height  then
			v.y = world_height-v.r
			if v.sy > 0 then
				v.sy = -v.sy
			end
		elseif v.y-v.r < -world_height then
			v.y = -world_height+v.r
			if v.sy < 0 then
				v.sy = -v.sy
			end
		end
		
		game.goal = math.max(v.m, game.goal)
	end
		
	if game.status == nil then
		if entities[player.i] == nil then
			game.status = "lost"
		elseif entities[player.i].m == game.goal then
			game.status = "won"
			map = "gravity I"
		end
	end
end

local units = 1000
local exponent = 4

-- 1) Die Menge der Masse wird angegeben.
-- 2) Die Menge der gewnschten Lebensformen wird angegeben
-- 3) Aus der Menge der Lebensformen wird die Anzahl der Abstufungen berechnet (units^0.5)

breeds = {} -- load the different types of breeds here
love.filesystem.include("breeds/player/definition.lua")
love.filesystem.include("breeds/default/definition.lua")

create_entity("player", world.matter/units ,0,0)
local i = 0
while i < units do
	i = i+1
	local matter = (math.random(10, 100)/10)^exponent/(10^(exponent-1))*world.matter/units
	local x = math.random((-world_width+radius(matter))*10, (world_width-radius(matter))*10)/10
	local y = math.random((-world_height+radius(matter))*10,(world_height-radius(matter))*10)/10
	
	local create = true
	for j, v in pairs(entities) do
		local d = ((x-v.x)^2+(y-v.y)^2)^0.5
		local r = radius(matter)+v.r
		if d < r*2 then
			i = i -1
			create = false
			break
		end
	end
	if create == true then
		sx = math.random(-30,30)/100
		sy = math.random(-30,30)/100
		create_entity("default", matter, x, y, sx, sy)
	end
end
